### A free/open-source library for quantitative finance

Classes | Public Types | Public Member Functions
CapFloor Class Reference
Financial instruments

Base class for cap-like instruments. More...

`#include <ql/instruments/capfloor.hpp>`

Inheritance diagram for CapFloor:
[legend]

List of all members.

## Classes

class | arguments
| Arguments for cap/floor calculation More...
class | engine
| base class for cap/floor engines More...

## Public Types

enum | Type { Cap, Floor, Collar }

## Public Member Functions

| CapFloor (Type type, const Leg &floatingLeg, const std::vector< Rate > &capRates, const std::vector< Rate > &floorRates)
| CapFloor (Type type, const Leg &floatingLeg, const std::vector< Rate > &strikes)
Rate | atmRate (const YieldTermStructure &discountCurve) const
Volatility | impliedVolatility (Real price, const Handle< YieldTermStructure > &disc, Volatility guess, Real accuracy=1.0e-4, Natural maxEvaluations=100, Volatility minVol=1.0e-7, Volatility maxVol=4.0) const
| implied term volatility
Instrument interface
bool | isExpired () const
| returns whether the instrument might have value greater than zero.
void | setupArguments (PricingEngine::arguments *) const
Inspectors
Type | type () const
const std::vector< Rate > & | capRates () const
const std::vector< Rate > & | floorRates () const
const Leg & | floatingLeg () const
Date | startDate () const
Date | maturityDate () const
boost::shared_ptr < FloatingRateCoupon > | lastFloatingRateCoupon () const
boost::shared_ptr< CapFloor > | optionlet (const Size n) const
| Returns the n-th optionlet as a new CapFloor with only one cash flow.

## Detailed Description

Base class for cap-like instruments.

Tests:
  - the correctness of the returned value is tested by checking that the price of a cap (resp. floor) decreases (resp. increases) with the strike rate.
  - the relationship between the values of caps, floors and the resulting collars is checked.
  - the put-call parity between the values of caps, floors and swaps is checked.
  - the correctness of the returned implied volatility is tested by using it for reproducing the target value.
  - the correctness of the returned value is tested by checking it against a known good value.

## Member Function Documentation

void setupArguments | ( | PricingEngine::arguments * |  | ) | const`[virtual]`

When a derived argument structure is defined for an instrument, this method should be overridden to fill it. This is mandatory in case a pricing engine is used.

Reimplemented from Instrument.